CREATE SEQUENCE REF_NOTIF_PRIORITY_ID_SEQ
  INCREMENT BY 1;

CREATE TABLE REF_NOTIFICATION_PRIORITY
(
  "ID" INTEGER NOT NULL,
  "NAME" VARCHAR2(50) NOT NULL,
  "WEIGHTING" INTEGER NOT NULL,
  "IMAGE_NAME" VARCHAR2(50) NOT NULL,
  CONSTRAINT REF_NOTIFICATION_PRIORITY_PKEY PRIMARY KEY ("ID")
);


CREATE OR REPLACE TRIGGER "REF_NOTIFICATION_PRIORITY_BIR"
BEFORE INSERT ON "REF_NOTIFICATION_PRIORITY"
FOR EACH ROW
 WHEN (NEW."ID" IS NULL) BEGIN
  SELECT REF_NOTIF_STATUS_ID_SEQ.NEXTVAL
  INTO   :NEW."ID"
  FROM   DUAL;
END;
/
ALTER TRIGGER "REF_NOTIFICATION_PRIORITY_BIR" ENABLE;


ALTER TABLE TBL_NOTIFICATION ADD
  FK_REF_NOTIFICATION_PRIORITY integer;
ALTER TABLE TBL_NOTIFICATION ADD
  TYPE varchar2(100);

ALTER TABLE TBL_NOTIFICATION
ADD CONSTRAINT FK_NOTIFICATION_FK_PRIORITY FOREIGN KEY (FK_REF_NOTIFICATION_PRIORITY)
         REFERENCES REF_NOTIFICATION_PRIORITY (ID);


-- INDEX: PUBLIC.FKI_NOTIFICATION_FK_STATUS
CREATE INDEX FKI_NOTIFICATION_FK_PRIORITY
 ON TBL_NOTIFICATION("FK_REF_NOTIFICATION_PRIORITY");

CREATE OR REPLACE VIEW VIEW_ACTIVE_NOTIFICATION AS
 SELECT S."ID",
    S."INCIDENT_ID",
    S."VERSION",
    S."FK_REF_BRANCH",
    S."FK_REF_NOTIFICATION_PRIORITY",
    S."NOTIFICATION_TEXT",
    S."FREE_TEXT",
    S."FREE_TEXT_EXTENDED",
    S."FK_REF_NOTIFICATION_STATUS",
    S."RESPONSIBILITY_FORWARDING",
    S."REMINDER_DATE",
    S."EXPECTED_FINISHED_DATE",
    S."RESPONSIBILITY_CONTROL_POINT",
    S."BEGIN_DATE",
    S."FINISHED_DATE",
    S."CREATE_USER",
    S."CREATE_DATE",
    S."MOD_USER",
    S."MOD_DATE",
    S."FK_REF_GRID_TERRITORY",
    S."ADMIN_FLAG",
    S."TYPE"
   FROM ( SELECT TBL_NOTIFICATION."ID",
            TBL_NOTIFICATION."INCIDENT_ID",
            TBL_NOTIFICATION."VERSION",
            TBL_NOTIFICATION."FK_REF_BRANCH",
            TBL_NOTIFICATION."FK_REF_NOTIFICATION_PRIORITY",
            TBL_NOTIFICATION."NOTIFICATION_TEXT",
            TBL_NOTIFICATION."FREE_TEXT",
            TBL_NOTIFICATION."FREE_TEXT_EXTENDED",
            TBL_NOTIFICATION."FK_REF_NOTIFICATION_STATUS",
            TBL_NOTIFICATION."RESPONSIBILITY_FORWARDING",
            TBL_NOTIFICATION."REMINDER_DATE",
            TBL_NOTIFICATION."EXPECTED_FINISHED_DATE",
            TBL_NOTIFICATION."RESPONSIBILITY_CONTROL_POINT",
            TBL_NOTIFICATION."BEGIN_DATE",
            TBL_NOTIFICATION."FINISHED_DATE",
            TBL_NOTIFICATION."CREATE_USER",
            TBL_NOTIFICATION."CREATE_DATE",
            TBL_NOTIFICATION."MOD_USER",
            TBL_NOTIFICATION."MOD_DATE",
            TBL_NOTIFICATION."FK_REF_GRID_TERRITORY",
            TBL_NOTIFICATION."ADMIN_FLAG",
            TBL_NOTIFICATION."TYPE",
            RANK() OVER (PARTITION BY TBL_NOTIFICATION."INCIDENT_ID" ORDER BY "TBL_NOTIFICATION"."VERSION" DESC) AS RANK
           FROM TBL_NOTIFICATION) S
  WHERE S.RANK = 1;




  CREATE SEQUENCE TBL_USER_SETTINGS_ID_SEQ
    INCREMENT BY 1;

  CREATE TABLE TBL_USER_SETTINGS
  (
    "ID" INTEGER NOT NULL,
    "USERNAME" VARCHAR2(50) NOT NULL,
    "SETTING_TYPE" VARCHAR2(50) NULL,
    "VALUE" VARCHAR2(2048) NOT NULL,
    CONSTRAINT TBL_USER_SETTINGS_PKEY PRIMARY KEY ("ID")
  );


  CREATE OR REPLACE TRIGGER "TBL_USER_SETTINGS_BIR"
  BEFORE INSERT ON "TBL_USER_SETTINGS"
  FOR EACH ROW
   WHEN (NEW."ID" IS NULL) BEGIN
    SELECT TBL_USER_SETTINGS_ID_SEQ.NEXTVAL
    INTO   :NEW."ID"
    FROM   DUAL;
  END;
  /
  ALTER TRIGGER "TBL_USER_SETTINGS_BIR" ENABLE;

CREATE UNIQUE INDEX TBL_USER_SET_UNIQUE_KEY ON TBL_USER_SETTINGS (USERNAME ASC, SETTING_TYPE ASC );






  CREATE SEQUENCE TBL_NOTIFICATION_MAILSENT_SEQ
    INCREMENT BY 1;

  CREATE TABLE TBL_NOTIFICATION_MAILSENT
  (
    "ID" INTEGER NOT NULL,
    "INCIDENT_ID" INTEGER NOT NULL,
    "MAIL_SENT" NUMBER NOT NULL,
    "DATE_MAIL_SENT" TIMESTAMP NOT NULL,
    CONSTRAINT TBL_NOTIF_MAIL_SENT_PKEY PRIMARY KEY ("ID")
  );


  CREATE OR REPLACE TRIGGER "TBL_NOTIFICATION_MAILSENT_BIR"
  BEFORE INSERT ON "TBL_NOTIFICATION_MAILSENT"
  FOR EACH ROW
   WHEN (NEW."ID" IS NULL) BEGIN
    SELECT TBL_NOTIFICATION_MAILSENT_SEQ.NEXTVAL
    INTO   :NEW."ID"
    FROM   DUAL;
  END;
  /
  ALTER TRIGGER "TBL_NOTIFICATION_MAILSENT_BIR" ENABLE;

create unique index IDX_RI_MAIL_SENT_UQ on TBL_NOTIFICATION_MAILSENT ( INCIDENT_ID );



  DELETE FROM REF_VERSION;
  INSERT INTO REF_VERSION VALUES (1, '2.0.0_ORA');


INSERT INTO "REF_NOTIFICATION_PRIORITY" ("ID", "NAME", "WEIGHTING", "IMAGE_NAME") VALUES ( 1, 'Wichtig', 30, 'prio-important-icon-web.svg');
INSERT INTO "REF_NOTIFICATION_PRIORITY" ("ID", "NAME", "WEIGHTING", "IMAGE_NAME") VALUES ( 2, 'Information', 20, 'prio-info-icon-web.svg');
INSERT INTO "REF_NOTIFICATION_PRIORITY" ("ID", "NAME", "WEIGHTING", "IMAGE_NAME") VALUES ( 3, 'Normal', 10, 'prio-normal-icon-web.svg');
